package edu.kit.iks.main.crypts;


public final class Cipher extends Identifyable{
	
	private /*@ spec_public */ final int ident;
	
	/* public model instance \seq observable; */
	/* represents observable = \seq_empty; */
	
	/* public model instance \seq visible; */
	/* represents visible = \seq_singleton(ident); */
	
	/*@ public ghost Key key; */
	/*@ public ghost Identifyable message; */ 
	
	//@ private invariant this.key != null;
	//@ private invariant this.message != null;
	
	/* proveable automatic */
	/*@ accessible \inv: this.*; */
	

	//this is never used! all methods used in for en- and decryption is used from SKE as an assumption.
	/* proveable automatic */
	/*@ public normal_behaviour
	  @ ensures (this.key == key) && (this.key.ident == key.ident) && (this.message == message) && this.key != null;
	  @ assignable ident;
	  */
	public Cipher(Key key, Object message) {
		super(0);
		ident = 0;
		//this.key = key;
		/*@ set this.message = message; */		
	}
	
	// Just assumption! No proof 
	/*@ public normal_behaviour
	  @ ensures    ((this.key.ident == k.ident) ==> (\result.ident == this.message.ident))
	  @         && ((this.key.ident != k.ident) ==> (\result == null));
	  */	 
	public /*@ nullable, strictly_pure */ Identifyable decrypt(Key k) {
	/*	if(this.key == k) {
			//return this.message;
			return null;
		} else {
			return null;
		}*/
		return null;
	}
}
